/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// CreateAvatarResponse struct for CreateAvatarResponse
type CreateAvatarResponse struct {
	// The URL of the uploaded avatar.
	AvatarUrl *string `json:"avatar_url,omitempty"`
}

// NewCreateAvatarResponse instantiates a new CreateAvatarResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateAvatarResponse() *CreateAvatarResponse {
	this := CreateAvatarResponse{}
	return &this
}

// NewCreateAvatarResponseWithDefaults instantiates a new CreateAvatarResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateAvatarResponseWithDefaults() *CreateAvatarResponse {
	this := CreateAvatarResponse{}
	return &this
}

// GetAvatarUrl returns the AvatarUrl field value if set, zero value otherwise.
func (o *CreateAvatarResponse) GetAvatarUrl() string {
	if o == nil || o.AvatarUrl == nil {
		var ret string
		return ret
	}
	return *o.AvatarUrl
}

// GetAvatarUrlOk returns a tuple with the AvatarUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateAvatarResponse) GetAvatarUrlOk() (*string, bool) {
	if o == nil || o.AvatarUrl == nil {
		return nil, false
	}
	return o.AvatarUrl, true
}

// HasAvatarUrl returns a boolean if a field has been set.
func (o *CreateAvatarResponse) HasAvatarUrl() bool {
	if o != nil && o.AvatarUrl != nil {
		return true
	}

	return false
}

// SetAvatarUrl gets a reference to the given string and assigns it to the AvatarUrl field.
func (o *CreateAvatarResponse) SetAvatarUrl(v string) {
	o.AvatarUrl = &v
}

func (o CreateAvatarResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.AvatarUrl != nil {
		toSerialize["avatar_url"] = o.AvatarUrl
	}
	return json.Marshal(toSerialize)
}

type NullableCreateAvatarResponse struct {
	value *CreateAvatarResponse
	isSet bool
}

func (v NullableCreateAvatarResponse) Get() *CreateAvatarResponse {
	return v.value
}

func (v *NullableCreateAvatarResponse) Set(val *CreateAvatarResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateAvatarResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateAvatarResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateAvatarResponse(val *CreateAvatarResponse) *NullableCreateAvatarResponse {
	return &NullableCreateAvatarResponse{value: val, isSet: true}
}

func (v NullableCreateAvatarResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateAvatarResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
