/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// CreateOrgAvatarResponse struct for CreateOrgAvatarResponse
type CreateOrgAvatarResponse struct {
	// The URL of the uploaded avatar.
	AvatarUrl *string `json:"avatar_url,omitempty"`
}

// NewCreateOrgAvatarResponse instantiates a new CreateOrgAvatarResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateOrgAvatarResponse() *CreateOrgAvatarResponse {
	this := CreateOrgAvatarResponse{}
	return &this
}

// NewCreateOrgAvatarResponseWithDefaults instantiates a new CreateOrgAvatarResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateOrgAvatarResponseWithDefaults() *CreateOrgAvatarResponse {
	this := CreateOrgAvatarResponse{}
	return &this
}

// GetAvatarUrl returns the AvatarUrl field value if set, zero value otherwise.
func (o *CreateOrgAvatarResponse) GetAvatarUrl() string {
	if o == nil || o.AvatarUrl == nil {
		var ret string
		return ret
	}
	return *o.AvatarUrl
}

// GetAvatarUrlOk returns a tuple with the AvatarUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateOrgAvatarResponse) GetAvatarUrlOk() (*string, bool) {
	if o == nil || o.AvatarUrl == nil {
		return nil, false
	}
	return o.AvatarUrl, true
}

// HasAvatarUrl returns a boolean if a field has been set.
func (o *CreateOrgAvatarResponse) HasAvatarUrl() bool {
	if o != nil && o.AvatarUrl != nil {
		return true
	}

	return false
}

// SetAvatarUrl gets a reference to the given string and assigns it to the AvatarUrl field.
func (o *CreateOrgAvatarResponse) SetAvatarUrl(v string) {
	o.AvatarUrl = &v
}

func (o CreateOrgAvatarResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.AvatarUrl != nil {
		toSerialize["avatar_url"] = o.AvatarUrl
	}
	return json.Marshal(toSerialize)
}

type NullableCreateOrgAvatarResponse struct {
	value *CreateOrgAvatarResponse
	isSet bool
}

func (v NullableCreateOrgAvatarResponse) Get() *CreateOrgAvatarResponse {
	return v.value
}

func (v *NullableCreateOrgAvatarResponse) Set(val *CreateOrgAvatarResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateOrgAvatarResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateOrgAvatarResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateOrgAvatarResponse(val *CreateOrgAvatarResponse) *NullableCreateOrgAvatarResponse {
	return &NullableCreateOrgAvatarResponse{value: val, isSet: true}
}

func (v NullableCreateOrgAvatarResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateOrgAvatarResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
