/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// CreateOrgRequest struct for CreateOrgRequest
type CreateOrgRequest struct {
	DisplayName *string `json:"display_name,omitempty"`
	Handle      string  `json:"handle"`
	PlanId      *string `json:"plan_id,omitempty"`
	Url         *string `json:"url,omitempty"`
}

// NewCreateOrgRequest instantiates a new CreateOrgRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateOrgRequest(handle string) *CreateOrgRequest {
	this := CreateOrgRequest{}
	this.Handle = handle
	return &this
}

// NewCreateOrgRequestWithDefaults instantiates a new CreateOrgRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateOrgRequestWithDefaults() *CreateOrgRequest {
	this := CreateOrgRequest{}
	return &this
}

// GetDisplayName returns the DisplayName field value if set, zero value otherwise.
func (o *CreateOrgRequest) GetDisplayName() string {
	if o == nil || o.DisplayName == nil {
		var ret string
		return ret
	}
	return *o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateOrgRequest) GetDisplayNameOk() (*string, bool) {
	if o == nil || o.DisplayName == nil {
		return nil, false
	}
	return o.DisplayName, true
}

// HasDisplayName returns a boolean if a field has been set.
func (o *CreateOrgRequest) HasDisplayName() bool {
	if o != nil && o.DisplayName != nil {
		return true
	}

	return false
}

// SetDisplayName gets a reference to the given string and assigns it to the DisplayName field.
func (o *CreateOrgRequest) SetDisplayName(v string) {
	o.DisplayName = &v
}

// GetHandle returns the Handle field value
func (o *CreateOrgRequest) GetHandle() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Handle
}

// GetHandleOk returns a tuple with the Handle field value
// and a boolean to check if the value has been set.
func (o *CreateOrgRequest) GetHandleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Handle, true
}

// SetHandle sets field value
func (o *CreateOrgRequest) SetHandle(v string) {
	o.Handle = v
}

// GetPlanId returns the PlanId field value if set, zero value otherwise.
func (o *CreateOrgRequest) GetPlanId() string {
	if o == nil || o.PlanId == nil {
		var ret string
		return ret
	}
	return *o.PlanId
}

// GetPlanIdOk returns a tuple with the PlanId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateOrgRequest) GetPlanIdOk() (*string, bool) {
	if o == nil || o.PlanId == nil {
		return nil, false
	}
	return o.PlanId, true
}

// HasPlanId returns a boolean if a field has been set.
func (o *CreateOrgRequest) HasPlanId() bool {
	if o != nil && o.PlanId != nil {
		return true
	}

	return false
}

// SetPlanId gets a reference to the given string and assigns it to the PlanId field.
func (o *CreateOrgRequest) SetPlanId(v string) {
	o.PlanId = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *CreateOrgRequest) GetUrl() string {
	if o == nil || o.Url == nil {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateOrgRequest) GetUrlOk() (*string, bool) {
	if o == nil || o.Url == nil {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *CreateOrgRequest) HasUrl() bool {
	if o != nil && o.Url != nil {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *CreateOrgRequest) SetUrl(v string) {
	o.Url = &v
}

func (o CreateOrgRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.DisplayName != nil {
		toSerialize["display_name"] = o.DisplayName
	}
	if true {
		toSerialize["handle"] = o.Handle
	}
	if o.PlanId != nil {
		toSerialize["plan_id"] = o.PlanId
	}
	if o.Url != nil {
		toSerialize["url"] = o.Url
	}
	return json.Marshal(toSerialize)
}

type NullableCreateOrgRequest struct {
	value *CreateOrgRequest
	isSet bool
}

func (v NullableCreateOrgRequest) Get() *CreateOrgRequest {
	return v.value
}

func (v *NullableCreateOrgRequest) Set(val *CreateOrgRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateOrgRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateOrgRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateOrgRequest(val *CreateOrgRequest) *NullableCreateOrgRequest {
	return &NullableCreateOrgRequest{value: val, isSet: true}
}

func (v NullableCreateOrgRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateOrgRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
