/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// CreateUserAvatarResponse struct for CreateUserAvatarResponse
type CreateUserAvatarResponse struct {
	// The URL of the uploaded avatar.
	AvatarUrl *string `json:"avatar_url,omitempty"`
}

// NewCreateUserAvatarResponse instantiates a new CreateUserAvatarResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateUserAvatarResponse() *CreateUserAvatarResponse {
	this := CreateUserAvatarResponse{}
	return &this
}

// NewCreateUserAvatarResponseWithDefaults instantiates a new CreateUserAvatarResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateUserAvatarResponseWithDefaults() *CreateUserAvatarResponse {
	this := CreateUserAvatarResponse{}
	return &this
}

// GetAvatarUrl returns the AvatarUrl field value if set, zero value otherwise.
func (o *CreateUserAvatarResponse) GetAvatarUrl() string {
	if o == nil || o.AvatarUrl == nil {
		var ret string
		return ret
	}
	return *o.AvatarUrl
}

// GetAvatarUrlOk returns a tuple with the AvatarUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserAvatarResponse) GetAvatarUrlOk() (*string, bool) {
	if o == nil || o.AvatarUrl == nil {
		return nil, false
	}
	return o.AvatarUrl, true
}

// HasAvatarUrl returns a boolean if a field has been set.
func (o *CreateUserAvatarResponse) HasAvatarUrl() bool {
	if o != nil && o.AvatarUrl != nil {
		return true
	}

	return false
}

// SetAvatarUrl gets a reference to the given string and assigns it to the AvatarUrl field.
func (o *CreateUserAvatarResponse) SetAvatarUrl(v string) {
	o.AvatarUrl = &v
}

func (o CreateUserAvatarResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.AvatarUrl != nil {
		toSerialize["avatar_url"] = o.AvatarUrl
	}
	return json.Marshal(toSerialize)
}

type NullableCreateUserAvatarResponse struct {
	value *CreateUserAvatarResponse
	isSet bool
}

func (v NullableCreateUserAvatarResponse) Get() *CreateUserAvatarResponse {
	return v.value
}

func (v *NullableCreateUserAvatarResponse) Set(val *CreateUserAvatarResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateUserAvatarResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateUserAvatarResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateUserAvatarResponse(val *CreateUserAvatarResponse) *NullableCreateUserAvatarResponse {
	return &NullableCreateUserAvatarResponse{value: val, isSet: true}
}

func (v NullableCreateUserAvatarResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateUserAvatarResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
