/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListIdentitiesResponse struct for ListIdentitiesResponse
type ListIdentitiesResponse struct {
	Items     *[]Identity `json:"items,omitempty"`
	NextToken *string     `json:"next_token,omitempty"`
}

// NewListIdentitiesResponse instantiates a new ListIdentitiesResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListIdentitiesResponse() *ListIdentitiesResponse {
	this := ListIdentitiesResponse{}
	return &this
}

// NewListIdentitiesResponseWithDefaults instantiates a new ListIdentitiesResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListIdentitiesResponseWithDefaults() *ListIdentitiesResponse {
	this := ListIdentitiesResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListIdentitiesResponse) GetItems() []Identity {
	if o == nil || o.Items == nil {
		var ret []Identity
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListIdentitiesResponse) GetItemsOk() (*[]Identity, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListIdentitiesResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []Identity and assigns it to the Items field.
func (o *ListIdentitiesResponse) SetItems(v []Identity) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListIdentitiesResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListIdentitiesResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListIdentitiesResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListIdentitiesResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListIdentitiesResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListIdentitiesResponse struct {
	value *ListIdentitiesResponse
	isSet bool
}

func (v NullableListIdentitiesResponse) Get() *ListIdentitiesResponse {
	return v.value
}

func (v *NullableListIdentitiesResponse) Set(val *ListIdentitiesResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListIdentitiesResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListIdentitiesResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListIdentitiesResponse(val *ListIdentitiesResponse) *NullableListIdentitiesResponse {
	return &NullableListIdentitiesResponse{value: val, isSet: true}
}

func (v NullableListIdentitiesResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListIdentitiesResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
