/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListTenantsResponse struct for ListTenantsResponse
type ListTenantsResponse struct {
	Items     *[]Tenant `json:"items,omitempty"`
	NextToken *string   `json:"next_token,omitempty"`
}

// NewListTenantsResponse instantiates a new ListTenantsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListTenantsResponse() *ListTenantsResponse {
	this := ListTenantsResponse{}
	return &this
}

// NewListTenantsResponseWithDefaults instantiates a new ListTenantsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListTenantsResponseWithDefaults() *ListTenantsResponse {
	this := ListTenantsResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListTenantsResponse) GetItems() []Tenant {
	if o == nil || o.Items == nil {
		var ret []Tenant
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListTenantsResponse) GetItemsOk() (*[]Tenant, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListTenantsResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []Tenant and assigns it to the Items field.
func (o *ListTenantsResponse) SetItems(v []Tenant) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListTenantsResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListTenantsResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListTenantsResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListTenantsResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListTenantsResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListTenantsResponse struct {
	value *ListTenantsResponse
	isSet bool
}

func (v NullableListTenantsResponse) Get() *ListTenantsResponse {
	return v.value
}

func (v *NullableListTenantsResponse) Set(val *ListTenantsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListTenantsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListTenantsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListTenantsResponse(val *ListTenantsResponse) *NullableListTenantsResponse {
	return &NullableListTenantsResponse{value: val, isSet: true}
}

func (v NullableListTenantsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListTenantsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
