/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListWorkspaceSnapshotsResponse struct for ListWorkspaceSnapshotsResponse
type ListWorkspaceSnapshotsResponse struct {
	// Metadata  ListResponseMetadata `json:\"metadata\"`
	Items     *[]WorkspaceSnapshot `json:"items,omitempty"`
	NextToken *string              `json:"next_token,omitempty"`
}

// NewListWorkspaceSnapshotsResponse instantiates a new ListWorkspaceSnapshotsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListWorkspaceSnapshotsResponse() *ListWorkspaceSnapshotsResponse {
	this := ListWorkspaceSnapshotsResponse{}
	return &this
}

// NewListWorkspaceSnapshotsResponseWithDefaults instantiates a new ListWorkspaceSnapshotsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListWorkspaceSnapshotsResponseWithDefaults() *ListWorkspaceSnapshotsResponse {
	this := ListWorkspaceSnapshotsResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListWorkspaceSnapshotsResponse) GetItems() []WorkspaceSnapshot {
	if o == nil || o.Items == nil {
		var ret []WorkspaceSnapshot
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListWorkspaceSnapshotsResponse) GetItemsOk() (*[]WorkspaceSnapshot, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListWorkspaceSnapshotsResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []WorkspaceSnapshot and assigns it to the Items field.
func (o *ListWorkspaceSnapshotsResponse) SetItems(v []WorkspaceSnapshot) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListWorkspaceSnapshotsResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListWorkspaceSnapshotsResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListWorkspaceSnapshotsResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListWorkspaceSnapshotsResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListWorkspaceSnapshotsResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListWorkspaceSnapshotsResponse struct {
	value *ListWorkspaceSnapshotsResponse
	isSet bool
}

func (v NullableListWorkspaceSnapshotsResponse) Get() *ListWorkspaceSnapshotsResponse {
	return v.value
}

func (v *NullableListWorkspaceSnapshotsResponse) Set(val *ListWorkspaceSnapshotsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListWorkspaceSnapshotsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListWorkspaceSnapshotsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListWorkspaceSnapshotsResponse(val *ListWorkspaceSnapshotsResponse) *NullableListWorkspaceSnapshotsResponse {
	return &NullableListWorkspaceSnapshotsResponse{value: val, isSet: true}
}

func (v NullableListWorkspaceSnapshotsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListWorkspaceSnapshotsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
