/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListWorkspacesResponse struct for ListWorkspacesResponse
type ListWorkspacesResponse struct {
	Items     *[]Workspace `json:"items,omitempty"`
	NextToken *string      `json:"next_token,omitempty"`
}

// NewListWorkspacesResponse instantiates a new ListWorkspacesResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListWorkspacesResponse() *ListWorkspacesResponse {
	this := ListWorkspacesResponse{}
	return &this
}

// NewListWorkspacesResponseWithDefaults instantiates a new ListWorkspacesResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListWorkspacesResponseWithDefaults() *ListWorkspacesResponse {
	this := ListWorkspacesResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListWorkspacesResponse) GetItems() []Workspace {
	if o == nil || o.Items == nil {
		var ret []Workspace
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListWorkspacesResponse) GetItemsOk() (*[]Workspace, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListWorkspacesResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []Workspace and assigns it to the Items field.
func (o *ListWorkspacesResponse) SetItems(v []Workspace) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListWorkspacesResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListWorkspacesResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListWorkspacesResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListWorkspacesResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListWorkspacesResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListWorkspacesResponse struct {
	value *ListWorkspacesResponse
	isSet bool
}

func (v NullableListWorkspacesResponse) Get() *ListWorkspacesResponse {
	return v.value
}

func (v *NullableListWorkspacesResponse) Set(val *ListWorkspacesResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListWorkspacesResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListWorkspacesResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListWorkspacesResponse(val *ListWorkspacesResponse) *NullableListWorkspacesResponse {
	return &NullableListWorkspacesResponse{value: val, isSet: true}
}

func (v NullableListWorkspacesResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListWorkspacesResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
