/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// TestConnectionRequest struct for TestConnectionRequest
type TestConnectionRequest struct {
	Config *map[string]interface{} `json:"config,omitempty"`
	Plugin string                  `json:"plugin"`
}

// NewTestConnectionRequest instantiates a new TestConnectionRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTestConnectionRequest(plugin string) *TestConnectionRequest {
	this := TestConnectionRequest{}
	this.Plugin = plugin
	return &this
}

// NewTestConnectionRequestWithDefaults instantiates a new TestConnectionRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTestConnectionRequestWithDefaults() *TestConnectionRequest {
	this := TestConnectionRequest{}
	return &this
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *TestConnectionRequest) GetConfig() map[string]interface{} {
	if o == nil || o.Config == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TestConnectionRequest) GetConfigOk() (*map[string]interface{}, bool) {
	if o == nil || o.Config == nil {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *TestConnectionRequest) HasConfig() bool {
	if o != nil && o.Config != nil {
		return true
	}

	return false
}

// SetConfig gets a reference to the given map[string]interface{} and assigns it to the Config field.
func (o *TestConnectionRequest) SetConfig(v map[string]interface{}) {
	o.Config = &v
}

// GetPlugin returns the Plugin field value
func (o *TestConnectionRequest) GetPlugin() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Plugin
}

// GetPluginOk returns a tuple with the Plugin field value
// and a boolean to check if the value has been set.
func (o *TestConnectionRequest) GetPluginOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Plugin, true
}

// SetPlugin sets field value
func (o *TestConnectionRequest) SetPlugin(v string) {
	o.Plugin = v
}

func (o TestConnectionRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Config != nil {
		toSerialize["config"] = o.Config
	}
	if true {
		toSerialize["plugin"] = o.Plugin
	}
	return json.Marshal(toSerialize)
}

type NullableTestConnectionRequest struct {
	value *TestConnectionRequest
	isSet bool
}

func (v NullableTestConnectionRequest) Get() *TestConnectionRequest {
	return v.value
}

func (v *NullableTestConnectionRequest) Set(val *TestConnectionRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableTestConnectionRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableTestConnectionRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTestConnectionRequest(val *TestConnectionRequest) *NullableTestConnectionRequest {
	return &NullableTestConnectionRequest{value: val, isSet: true}
}

func (v NullableTestConnectionRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTestConnectionRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
