/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// UpdateWorkspaceRequest struct for UpdateWorkspaceRequest
type UpdateWorkspaceRequest struct {
	DbVolumeSizeBytes *int64 `json:"db_volume_size_bytes,omitempty"`
	// paused is not yet supported for Workspace
	DesiredState *string `json:"desired_state,omitempty"`
	Handle       *string `json:"handle,omitempty"`
}

// NewUpdateWorkspaceRequest instantiates a new UpdateWorkspaceRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUpdateWorkspaceRequest() *UpdateWorkspaceRequest {
	this := UpdateWorkspaceRequest{}
	return &this
}

// NewUpdateWorkspaceRequestWithDefaults instantiates a new UpdateWorkspaceRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUpdateWorkspaceRequestWithDefaults() *UpdateWorkspaceRequest {
	this := UpdateWorkspaceRequest{}
	return &this
}

// GetDbVolumeSizeBytes returns the DbVolumeSizeBytes field value if set, zero value otherwise.
func (o *UpdateWorkspaceRequest) GetDbVolumeSizeBytes() int64 {
	if o == nil || o.DbVolumeSizeBytes == nil {
		var ret int64
		return ret
	}
	return *o.DbVolumeSizeBytes
}

// GetDbVolumeSizeBytesOk returns a tuple with the DbVolumeSizeBytes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateWorkspaceRequest) GetDbVolumeSizeBytesOk() (*int64, bool) {
	if o == nil || o.DbVolumeSizeBytes == nil {
		return nil, false
	}
	return o.DbVolumeSizeBytes, true
}

// HasDbVolumeSizeBytes returns a boolean if a field has been set.
func (o *UpdateWorkspaceRequest) HasDbVolumeSizeBytes() bool {
	if o != nil && o.DbVolumeSizeBytes != nil {
		return true
	}

	return false
}

// SetDbVolumeSizeBytes gets a reference to the given int64 and assigns it to the DbVolumeSizeBytes field.
func (o *UpdateWorkspaceRequest) SetDbVolumeSizeBytes(v int64) {
	o.DbVolumeSizeBytes = &v
}

// GetDesiredState returns the DesiredState field value if set, zero value otherwise.
func (o *UpdateWorkspaceRequest) GetDesiredState() string {
	if o == nil || o.DesiredState == nil {
		var ret string
		return ret
	}
	return *o.DesiredState
}

// GetDesiredStateOk returns a tuple with the DesiredState field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateWorkspaceRequest) GetDesiredStateOk() (*string, bool) {
	if o == nil || o.DesiredState == nil {
		return nil, false
	}
	return o.DesiredState, true
}

// HasDesiredState returns a boolean if a field has been set.
func (o *UpdateWorkspaceRequest) HasDesiredState() bool {
	if o != nil && o.DesiredState != nil {
		return true
	}

	return false
}

// SetDesiredState gets a reference to the given string and assigns it to the DesiredState field.
func (o *UpdateWorkspaceRequest) SetDesiredState(v string) {
	o.DesiredState = &v
}

// GetHandle returns the Handle field value if set, zero value otherwise.
func (o *UpdateWorkspaceRequest) GetHandle() string {
	if o == nil || o.Handle == nil {
		var ret string
		return ret
	}
	return *o.Handle
}

// GetHandleOk returns a tuple with the Handle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateWorkspaceRequest) GetHandleOk() (*string, bool) {
	if o == nil || o.Handle == nil {
		return nil, false
	}
	return o.Handle, true
}

// HasHandle returns a boolean if a field has been set.
func (o *UpdateWorkspaceRequest) HasHandle() bool {
	if o != nil && o.Handle != nil {
		return true
	}

	return false
}

// SetHandle gets a reference to the given string and assigns it to the Handle field.
func (o *UpdateWorkspaceRequest) SetHandle(v string) {
	o.Handle = &v
}

func (o UpdateWorkspaceRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.DbVolumeSizeBytes != nil {
		toSerialize["db_volume_size_bytes"] = o.DbVolumeSizeBytes
	}
	if o.DesiredState != nil {
		toSerialize["desired_state"] = o.DesiredState
	}
	if o.Handle != nil {
		toSerialize["handle"] = o.Handle
	}
	return json.Marshal(toSerialize)
}

type NullableUpdateWorkspaceRequest struct {
	value *UpdateWorkspaceRequest
	isSet bool
}

func (v NullableUpdateWorkspaceRequest) Get() *UpdateWorkspaceRequest {
	return v.value
}

func (v *NullableUpdateWorkspaceRequest) Set(val *UpdateWorkspaceRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableUpdateWorkspaceRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableUpdateWorkspaceRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUpdateWorkspaceRequest(val *UpdateWorkspaceRequest) *NullableUpdateWorkspaceRequest {
	return &NullableUpdateWorkspaceRequest{value: val, isSet: true}
}

func (v NullableUpdateWorkspaceRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUpdateWorkspaceRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
