/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// User struct for User
type User struct {
	AvatarUrl *string      `json:"avatar_url,omitempty"`
	Billing   *BillingInfo `json:"billing,omitempty"`
	// The user created time.
	CreatedAt   string  `json:"created_at"`
	DisplayName *string `json:"display_name,omitempty"`
	// The handle name of a user.
	Handle string `json:"handle"`
	// The unique identifier of a user.
	Id                string  `json:"id"`
	PreviewAccessMode *string `json:"preview_access_mode,omitempty"`
	// The status of the user i.e accepted or pending.
	Status string `json:"status"`
	// The unique identifier of the tenant the user belongs to.
	TenantId string `json:"tenant_id"`
	// The time which user and temporary auth tokens must be issued after.
	TokenMinIssuedAt *string `json:"token_min_issued_at,omitempty"`
	// The user updated time.
	UpdatedAt             *string `json:"updated_at,omitempty"`
	Url                   *string `json:"url,omitempty"`
	UsageComputeAction    *string `json:"usage_compute_action,omitempty"`
	UsageComputeThreshold *int64  `json:"usage_compute_threshold,omitempty"`
	UsageStorageAction    *string `json:"usage_storage_action,omitempty"`
	UsageStorageThreshold *int64  `json:"usage_storage_threshold,omitempty"`
	// The current version of a user.
	VersionId int32 `json:"version_id"`
}

// NewUser instantiates a new User object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUser(createdAt string, handle string, id string, status string, tenantId string, versionId int32) *User {
	this := User{}
	this.CreatedAt = createdAt
	this.Handle = handle
	this.Id = id
	this.Status = status
	this.TenantId = tenantId
	this.VersionId = versionId
	return &this
}

// NewUserWithDefaults instantiates a new User object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserWithDefaults() *User {
	this := User{}
	return &this
}

// GetAvatarUrl returns the AvatarUrl field value if set, zero value otherwise.
func (o *User) GetAvatarUrl() string {
	if o == nil || o.AvatarUrl == nil {
		var ret string
		return ret
	}
	return *o.AvatarUrl
}

// GetAvatarUrlOk returns a tuple with the AvatarUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetAvatarUrlOk() (*string, bool) {
	if o == nil || o.AvatarUrl == nil {
		return nil, false
	}
	return o.AvatarUrl, true
}

// HasAvatarUrl returns a boolean if a field has been set.
func (o *User) HasAvatarUrl() bool {
	if o != nil && o.AvatarUrl != nil {
		return true
	}

	return false
}

// SetAvatarUrl gets a reference to the given string and assigns it to the AvatarUrl field.
func (o *User) SetAvatarUrl(v string) {
	o.AvatarUrl = &v
}

// GetBilling returns the Billing field value if set, zero value otherwise.
func (o *User) GetBilling() BillingInfo {
	if o == nil || o.Billing == nil {
		var ret BillingInfo
		return ret
	}
	return *o.Billing
}

// GetBillingOk returns a tuple with the Billing field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetBillingOk() (*BillingInfo, bool) {
	if o == nil || o.Billing == nil {
		return nil, false
	}
	return o.Billing, true
}

// HasBilling returns a boolean if a field has been set.
func (o *User) HasBilling() bool {
	if o != nil && o.Billing != nil {
		return true
	}

	return false
}

// SetBilling gets a reference to the given BillingInfo and assigns it to the Billing field.
func (o *User) SetBilling(v BillingInfo) {
	o.Billing = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *User) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *User) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *User) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetDisplayName returns the DisplayName field value if set, zero value otherwise.
func (o *User) GetDisplayName() string {
	if o == nil || o.DisplayName == nil {
		var ret string
		return ret
	}
	return *o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetDisplayNameOk() (*string, bool) {
	if o == nil || o.DisplayName == nil {
		return nil, false
	}
	return o.DisplayName, true
}

// HasDisplayName returns a boolean if a field has been set.
func (o *User) HasDisplayName() bool {
	if o != nil && o.DisplayName != nil {
		return true
	}

	return false
}

// SetDisplayName gets a reference to the given string and assigns it to the DisplayName field.
func (o *User) SetDisplayName(v string) {
	o.DisplayName = &v
}

// GetHandle returns the Handle field value
func (o *User) GetHandle() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Handle
}

// GetHandleOk returns a tuple with the Handle field value
// and a boolean to check if the value has been set.
func (o *User) GetHandleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Handle, true
}

// SetHandle sets field value
func (o *User) SetHandle(v string) {
	o.Handle = v
}

// GetId returns the Id field value
func (o *User) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *User) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *User) SetId(v string) {
	o.Id = v
}

// GetPreviewAccessMode returns the PreviewAccessMode field value if set, zero value otherwise.
func (o *User) GetPreviewAccessMode() string {
	if o == nil || o.PreviewAccessMode == nil {
		var ret string
		return ret
	}
	return *o.PreviewAccessMode
}

// GetPreviewAccessModeOk returns a tuple with the PreviewAccessMode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetPreviewAccessModeOk() (*string, bool) {
	if o == nil || o.PreviewAccessMode == nil {
		return nil, false
	}
	return o.PreviewAccessMode, true
}

// HasPreviewAccessMode returns a boolean if a field has been set.
func (o *User) HasPreviewAccessMode() bool {
	if o != nil && o.PreviewAccessMode != nil {
		return true
	}

	return false
}

// SetPreviewAccessMode gets a reference to the given string and assigns it to the PreviewAccessMode field.
func (o *User) SetPreviewAccessMode(v string) {
	o.PreviewAccessMode = &v
}

// GetStatus returns the Status field value
func (o *User) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *User) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *User) SetStatus(v string) {
	o.Status = v
}

// GetTenantId returns the TenantId field value
func (o *User) GetTenantId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TenantId
}

// GetTenantIdOk returns a tuple with the TenantId field value
// and a boolean to check if the value has been set.
func (o *User) GetTenantIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TenantId, true
}

// SetTenantId sets field value
func (o *User) SetTenantId(v string) {
	o.TenantId = v
}

// GetTokenMinIssuedAt returns the TokenMinIssuedAt field value if set, zero value otherwise.
func (o *User) GetTokenMinIssuedAt() string {
	if o == nil || o.TokenMinIssuedAt == nil {
		var ret string
		return ret
	}
	return *o.TokenMinIssuedAt
}

// GetTokenMinIssuedAtOk returns a tuple with the TokenMinIssuedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetTokenMinIssuedAtOk() (*string, bool) {
	if o == nil || o.TokenMinIssuedAt == nil {
		return nil, false
	}
	return o.TokenMinIssuedAt, true
}

// HasTokenMinIssuedAt returns a boolean if a field has been set.
func (o *User) HasTokenMinIssuedAt() bool {
	if o != nil && o.TokenMinIssuedAt != nil {
		return true
	}

	return false
}

// SetTokenMinIssuedAt gets a reference to the given string and assigns it to the TokenMinIssuedAt field.
func (o *User) SetTokenMinIssuedAt(v string) {
	o.TokenMinIssuedAt = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *User) GetUpdatedAt() string {
	if o == nil || o.UpdatedAt == nil {
		var ret string
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetUpdatedAtOk() (*string, bool) {
	if o == nil || o.UpdatedAt == nil {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *User) HasUpdatedAt() bool {
	if o != nil && o.UpdatedAt != nil {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given string and assigns it to the UpdatedAt field.
func (o *User) SetUpdatedAt(v string) {
	o.UpdatedAt = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *User) GetUrl() string {
	if o == nil || o.Url == nil {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetUrlOk() (*string, bool) {
	if o == nil || o.Url == nil {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *User) HasUrl() bool {
	if o != nil && o.Url != nil {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *User) SetUrl(v string) {
	o.Url = &v
}

// GetUsageComputeAction returns the UsageComputeAction field value if set, zero value otherwise.
func (o *User) GetUsageComputeAction() string {
	if o == nil || o.UsageComputeAction == nil {
		var ret string
		return ret
	}
	return *o.UsageComputeAction
}

// GetUsageComputeActionOk returns a tuple with the UsageComputeAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetUsageComputeActionOk() (*string, bool) {
	if o == nil || o.UsageComputeAction == nil {
		return nil, false
	}
	return o.UsageComputeAction, true
}

// HasUsageComputeAction returns a boolean if a field has been set.
func (o *User) HasUsageComputeAction() bool {
	if o != nil && o.UsageComputeAction != nil {
		return true
	}

	return false
}

// SetUsageComputeAction gets a reference to the given string and assigns it to the UsageComputeAction field.
func (o *User) SetUsageComputeAction(v string) {
	o.UsageComputeAction = &v
}

// GetUsageComputeThreshold returns the UsageComputeThreshold field value if set, zero value otherwise.
func (o *User) GetUsageComputeThreshold() int64 {
	if o == nil || o.UsageComputeThreshold == nil {
		var ret int64
		return ret
	}
	return *o.UsageComputeThreshold
}

// GetUsageComputeThresholdOk returns a tuple with the UsageComputeThreshold field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetUsageComputeThresholdOk() (*int64, bool) {
	if o == nil || o.UsageComputeThreshold == nil {
		return nil, false
	}
	return o.UsageComputeThreshold, true
}

// HasUsageComputeThreshold returns a boolean if a field has been set.
func (o *User) HasUsageComputeThreshold() bool {
	if o != nil && o.UsageComputeThreshold != nil {
		return true
	}

	return false
}

// SetUsageComputeThreshold gets a reference to the given int64 and assigns it to the UsageComputeThreshold field.
func (o *User) SetUsageComputeThreshold(v int64) {
	o.UsageComputeThreshold = &v
}

// GetUsageStorageAction returns the UsageStorageAction field value if set, zero value otherwise.
func (o *User) GetUsageStorageAction() string {
	if o == nil || o.UsageStorageAction == nil {
		var ret string
		return ret
	}
	return *o.UsageStorageAction
}

// GetUsageStorageActionOk returns a tuple with the UsageStorageAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetUsageStorageActionOk() (*string, bool) {
	if o == nil || o.UsageStorageAction == nil {
		return nil, false
	}
	return o.UsageStorageAction, true
}

// HasUsageStorageAction returns a boolean if a field has been set.
func (o *User) HasUsageStorageAction() bool {
	if o != nil && o.UsageStorageAction != nil {
		return true
	}

	return false
}

// SetUsageStorageAction gets a reference to the given string and assigns it to the UsageStorageAction field.
func (o *User) SetUsageStorageAction(v string) {
	o.UsageStorageAction = &v
}

// GetUsageStorageThreshold returns the UsageStorageThreshold field value if set, zero value otherwise.
func (o *User) GetUsageStorageThreshold() int64 {
	if o == nil || o.UsageStorageThreshold == nil {
		var ret int64
		return ret
	}
	return *o.UsageStorageThreshold
}

// GetUsageStorageThresholdOk returns a tuple with the UsageStorageThreshold field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *User) GetUsageStorageThresholdOk() (*int64, bool) {
	if o == nil || o.UsageStorageThreshold == nil {
		return nil, false
	}
	return o.UsageStorageThreshold, true
}

// HasUsageStorageThreshold returns a boolean if a field has been set.
func (o *User) HasUsageStorageThreshold() bool {
	if o != nil && o.UsageStorageThreshold != nil {
		return true
	}

	return false
}

// SetUsageStorageThreshold gets a reference to the given int64 and assigns it to the UsageStorageThreshold field.
func (o *User) SetUsageStorageThreshold(v int64) {
	o.UsageStorageThreshold = &v
}

// GetVersionId returns the VersionId field value
func (o *User) GetVersionId() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.VersionId
}

// GetVersionIdOk returns a tuple with the VersionId field value
// and a boolean to check if the value has been set.
func (o *User) GetVersionIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.VersionId, true
}

// SetVersionId sets field value
func (o *User) SetVersionId(v int32) {
	o.VersionId = v
}

func (o User) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.AvatarUrl != nil {
		toSerialize["avatar_url"] = o.AvatarUrl
	}
	if o.Billing != nil {
		toSerialize["billing"] = o.Billing
	}
	if true {
		toSerialize["created_at"] = o.CreatedAt
	}
	if o.DisplayName != nil {
		toSerialize["display_name"] = o.DisplayName
	}
	if true {
		toSerialize["handle"] = o.Handle
	}
	if true {
		toSerialize["id"] = o.Id
	}
	if o.PreviewAccessMode != nil {
		toSerialize["preview_access_mode"] = o.PreviewAccessMode
	}
	if true {
		toSerialize["status"] = o.Status
	}
	if true {
		toSerialize["tenant_id"] = o.TenantId
	}
	if o.TokenMinIssuedAt != nil {
		toSerialize["token_min_issued_at"] = o.TokenMinIssuedAt
	}
	if o.UpdatedAt != nil {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	if o.Url != nil {
		toSerialize["url"] = o.Url
	}
	if o.UsageComputeAction != nil {
		toSerialize["usage_compute_action"] = o.UsageComputeAction
	}
	if o.UsageComputeThreshold != nil {
		toSerialize["usage_compute_threshold"] = o.UsageComputeThreshold
	}
	if o.UsageStorageAction != nil {
		toSerialize["usage_storage_action"] = o.UsageStorageAction
	}
	if o.UsageStorageThreshold != nil {
		toSerialize["usage_storage_threshold"] = o.UsageStorageThreshold
	}
	if true {
		toSerialize["version_id"] = o.VersionId
	}
	return json.Marshal(toSerialize)
}

type NullableUser struct {
	value *User
	isSet bool
}

func (v NullableUser) Get() *User {
	return v.value
}

func (v *NullableUser) Set(val *User) {
	v.value = val
	v.isSet = true
}

func (v NullableUser) IsSet() bool {
	return v.isSet
}

func (v *NullableUser) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUser(val *User) *NullableUser {
	return &NullableUser{value: val, isSet: true}
}

func (v NullableUser) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUser) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
