/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// UserLoginRequest struct for UserLoginRequest
type UserLoginRequest struct {
	Email string  `json:"email"`
	State *string `json:"state,omitempty"`
}

// NewUserLoginRequest instantiates a new UserLoginRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserLoginRequest(email string) *UserLoginRequest {
	this := UserLoginRequest{}
	this.Email = email
	return &this
}

// NewUserLoginRequestWithDefaults instantiates a new UserLoginRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserLoginRequestWithDefaults() *UserLoginRequest {
	this := UserLoginRequest{}
	return &this
}

// GetEmail returns the Email field value
func (o *UserLoginRequest) GetEmail() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Email
}

// GetEmailOk returns a tuple with the Email field value
// and a boolean to check if the value has been set.
func (o *UserLoginRequest) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Email, true
}

// SetEmail sets field value
func (o *UserLoginRequest) SetEmail(v string) {
	o.Email = v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *UserLoginRequest) GetState() string {
	if o == nil || o.State == nil {
		var ret string
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserLoginRequest) GetStateOk() (*string, bool) {
	if o == nil || o.State == nil {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *UserLoginRequest) HasState() bool {
	if o != nil && o.State != nil {
		return true
	}

	return false
}

// SetState gets a reference to the given string and assigns it to the State field.
func (o *UserLoginRequest) SetState(v string) {
	o.State = &v
}

func (o UserLoginRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["email"] = o.Email
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	return json.Marshal(toSerialize)
}

type NullableUserLoginRequest struct {
	value *UserLoginRequest
	isSet bool
}

func (v NullableUserLoginRequest) Get() *UserLoginRequest {
	return v.value
}

func (v *NullableUserLoginRequest) Set(val *UserLoginRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableUserLoginRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableUserLoginRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserLoginRequest(val *UserLoginRequest) *NullableUserLoginRequest {
	return &NullableUserLoginRequest{value: val, isSet: true}
}

func (v NullableUserLoginRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserLoginRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
