/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// UserSignupRequest struct for UserSignupRequest
type UserSignupRequest struct {
	Email string  `json:"email"`
	State *string `json:"state,omitempty"`
}

// NewUserSignupRequest instantiates a new UserSignupRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserSignupRequest(email string) *UserSignupRequest {
	this := UserSignupRequest{}
	this.Email = email
	return &this
}

// NewUserSignupRequestWithDefaults instantiates a new UserSignupRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserSignupRequestWithDefaults() *UserSignupRequest {
	this := UserSignupRequest{}
	return &this
}

// GetEmail returns the Email field value
func (o *UserSignupRequest) GetEmail() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Email
}

// GetEmailOk returns a tuple with the Email field value
// and a boolean to check if the value has been set.
func (o *UserSignupRequest) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Email, true
}

// SetEmail sets field value
func (o *UserSignupRequest) SetEmail(v string) {
	o.Email = v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *UserSignupRequest) GetState() string {
	if o == nil || o.State == nil {
		var ret string
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserSignupRequest) GetStateOk() (*string, bool) {
	if o == nil || o.State == nil {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *UserSignupRequest) HasState() bool {
	if o != nil && o.State != nil {
		return true
	}

	return false
}

// SetState gets a reference to the given string and assigns it to the State field.
func (o *UserSignupRequest) SetState(v string) {
	o.State = &v
}

func (o UserSignupRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["email"] = o.Email
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	return json.Marshal(toSerialize)
}

type NullableUserSignupRequest struct {
	value *UserSignupRequest
	isSet bool
}

func (v NullableUserSignupRequest) Get() *UserSignupRequest {
	return v.value
}

func (v *NullableUserSignupRequest) Set(val *UserSignupRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableUserSignupRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableUserSignupRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserSignupRequest(val *UserSignupRequest) *NullableUserSignupRequest {
	return &NullableUserSignupRequest{value: val, isSet: true}
}

func (v NullableUserSignupRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserSignupRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
