/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// WorkspaceSchemaTableColumn struct for WorkspaceSchemaTableColumn
type WorkspaceSchemaTableColumn struct {
	DataType    string  `json:"data_type"`
	Description *string `json:"description,omitempty"`
	Name        string  `json:"name"`
}

// NewWorkspaceSchemaTableColumn instantiates a new WorkspaceSchemaTableColumn object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWorkspaceSchemaTableColumn(dataType string, name string) *WorkspaceSchemaTableColumn {
	this := WorkspaceSchemaTableColumn{}
	this.DataType = dataType
	this.Name = name
	return &this
}

// NewWorkspaceSchemaTableColumnWithDefaults instantiates a new WorkspaceSchemaTableColumn object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWorkspaceSchemaTableColumnWithDefaults() *WorkspaceSchemaTableColumn {
	this := WorkspaceSchemaTableColumn{}
	return &this
}

// GetDataType returns the DataType field value
func (o *WorkspaceSchemaTableColumn) GetDataType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DataType
}

// GetDataTypeOk returns a tuple with the DataType field value
// and a boolean to check if the value has been set.
func (o *WorkspaceSchemaTableColumn) GetDataTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DataType, true
}

// SetDataType sets field value
func (o *WorkspaceSchemaTableColumn) SetDataType(v string) {
	o.DataType = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *WorkspaceSchemaTableColumn) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceSchemaTableColumn) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *WorkspaceSchemaTableColumn) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *WorkspaceSchemaTableColumn) SetDescription(v string) {
	o.Description = &v
}

// GetName returns the Name field value
func (o *WorkspaceSchemaTableColumn) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *WorkspaceSchemaTableColumn) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *WorkspaceSchemaTableColumn) SetName(v string) {
	o.Name = v
}

func (o WorkspaceSchemaTableColumn) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["data_type"] = o.DataType
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if true {
		toSerialize["name"] = o.Name
	}
	return json.Marshal(toSerialize)
}

type NullableWorkspaceSchemaTableColumn struct {
	value *WorkspaceSchemaTableColumn
	isSet bool
}

func (v NullableWorkspaceSchemaTableColumn) Get() *WorkspaceSchemaTableColumn {
	return v.value
}

func (v *NullableWorkspaceSchemaTableColumn) Set(val *WorkspaceSchemaTableColumn) {
	v.value = val
	v.isSet = true
}

func (v NullableWorkspaceSchemaTableColumn) IsSet() bool {
	return v.isSet
}

func (v *NullableWorkspaceSchemaTableColumn) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWorkspaceSchemaTableColumn(val *WorkspaceSchemaTableColumn) *NullableWorkspaceSchemaTableColumn {
	return &NullableWorkspaceSchemaTableColumn{value: val, isSet: true}
}

func (v NullableWorkspaceSchemaTableColumn) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWorkspaceSchemaTableColumn) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
